{% extends 'atila-vue/vue.j2' %}

{% block head_style %}
  <link href="{{ '{}/bootstrap@5.3/dist/css/bootstrap.min.css'.format (cdn) }}" rel="stylesheet">
  <link rel="stylesheet" href="{{ '{}/bootstrap-icons/font/bootstrap-icons.min.css'.format (cdn) }}">
  <link rel="stylesheet" href="{{ request_context.static ('atila-vue/css/bs-addendum.css') }}">
  {{ super () }}
{% endblock %}

{% block state_map %}
  {{ super () }}
  {{ map_data ('$bootstrap', {'modal': {'buttons': []}, 'toast': {'buttons': []} } ) }}
{% endblock %}

{% block content_foot %}
  {{ super ()}}
  <div class="modal" id="bs-modal" data-bs-backdrop="static">
    <div class="modal-dialog modal-dialog-centered modal-md">
      <div class="modal-content">
        <div class="modal-header py-1 px-3">
          <h5 class="modal-title">
            <span class="fs-6" v-html="state.$bootstrap.modal.icon"></span>
            <span class="pl-2 fs-6">{{ "state.$bootstrap.modal.title" | vue }}</span>
          </h5>
          <button type="button" class="btn-close btn-sm" data-bs-dismiss="modal" aria-label="Close"></button>
        </div>
        <div class="modal-body pl-9 py-2">
          <p v-html="state.$bootstrap.modal.text"></p>
          <div v-if="!!state.$bootstrap.modal.textConfirm" style="width: 94%;">
            <div class="mb-1">Enter the following to confirm: <span class="bg-grey px-1">{{ "state.$bootstrap.modal.textConfirm" | vue}}</span></div>
            <input type="text" v-model="state.$bootstrap.modal.retypeTextConfirm"
              class="form-control form-control-sm"
              :placeholder="'Enter exact: ' + state.$bootstrap.modal.textConfirm">
          </div>
        </div>
        <div class="modal-footer pl-9 py-1">
          <button v-if="state.$bootstrap.modal.closeButtonText!==null" type="button" class="btn btn-secondary" data-bs-dismiss="modal">{{ "state.$bootstrap.modal.closeButtonText" | vue }}</button>
          <template v-for="btn in state.$bootstrap.modal.buttons" :key="btn.text">
            <button v-if='!!btn.run' type="button" class="btn" data-bs-dismiss="modal" :class="btn.class_"
              :disabled="(btn.needTextConfirm || state.$bootstrap.modal.buttons.length == 1) && !!state.$bootstrap.modal.textConfirm && state.$bootstrap.modal.textConfirm != state.$bootstrap.modal.retypeTextConfirm"
              @click="callFunction (btn.run)">{{ "btn.text" | vue}}</button>
            {% if context.vue_config.use_router %}
              <button v-else='!!btn.to' type="button" class="btn" :class="btn.class_" data-bs-dismiss="modal" :onClick="`router.push ('${btn.to}');`">{{ "btn.text" | vue}}</a>
            {% else %}
              <a v-else='!!btn.to' class="btn" :class="btn.class_" :href="btn.to">{{ "btn.text" | vue}}</a>
            {% endif %}
          </template>
        </div>
      </div>
    </div>
  </div>

  {% block toast_container %}
  <div class="toast-container fixed-bottom" style="z-index: 11000">
    <div class="position-fixed bottom-0 end-0 p-3"></div>
  </div>
  {% endblock %}

  {% block alert_container %}
  <div class="alert-container p-1 fixed-bottom" style="z-index: 10000"></div>
  {% endblock %}

  <div class="modal" tabindex="-1" id="bs-wait-app" data-bs-backdrop="static">
    <div class="modal-dialog modal-dialog-centered">
      <div class="modal-content">
        <div class="modal-body">
          <div class="d-flex justify-content-between">
            <div class="d-flex">
              <div style="min-width: 30px;" class="ml-6 my-7" v-if="state.$bootstrap.modal.spin !== false">
                <div class="spinner-border" role="status">
                  <span class="visually-hidden">Loading...</span>
                </div>
              </div>
              <div class="my-7 mx-6 text-blue-grey-darken-2">
                <div class="h5 fw-bold">{{ "state.$bootstrap.modal.title" | vue }}</div>
                <div v-if="!!state.$bootstrap.modal.text" class="text-grey" v-html="state.$bootstrap.modal.text"></div>
              </div>
            </div>

            <div v-if="!!state.$bootstrap.modal.logo" class="mr-6 my-7">
              <img :src="state.$bootstrap.modal.logo" width="54">
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>


  {{ super () }}
{% endblock %}

{% block body_trailer_script %}
  {{ super () }}
  <script src="{{ '{}/bootstrap@5.3/dist/js/bootstrap.bundle.min.js'.format (cdn) }}"></script>
  <script>
    function _createIcon (type) {
      if (type == 'error')
        icon = '<i class="bi bi-exclamation-diamond-fill text-red-darken-1"></i>'
      else if (type == 'warning')
        icon = '<i class="bi bi-dash-circle-fill text-amber-darken-4"></i>'
      else if (type == 'question')
        icon = '<i class="bi bi-question-diamond-fill text-amber-darken-4"></i>'
      else if (type == 'ok')
        icon = '<i class="bi bi-check-circle-fill light-green-darken-3"></i>'
      else
        icon = '<i class="bi bi-info-circle-fill text-green-darken-3"></i>'
      return icon
    }

    function bs_wait (option) {
      if (typeof (option) == "undefined") {
        const w = bootstrap.Modal.getInstance (document.getElementById('bs-wait-app'))
        if (!!w) {
          w.hide ()
        }
        return w
      }
      store.state.$bootstrap.modal = option
      const w = new bootstrap.Modal (document.getElementById('bs-wait-app'))
      w.show ()
    }

    function bs_modal (option) {
      if (typeof (option) == "undefined") {
        const w = bootstrap.Modal.getInstance (document.getElementById('bs-modal'))
        w.hide ()
        return w
      }
      if (!("closeButtonText" in option)) { option.closeButtonText = "Close" }
      if (!("buttons" in option)) { option.buttons = [] }
      if (!("icon" in option)) { option.icon = "info" }
      if (("textConfirm" in option)) {
        option.retypeTextConfirm = ""
      }

      option.icon = _createIcon (option.icon)
      store.state.$bootstrap.modal = option
      const w = new bootstrap.Modal (document.getElementById('bs-modal'))
      w.show ()
    }

    function bs_cleanup (container, alert, func_ids) {
      try {
        if (!!alert) {
          container.removeChild (alert)
          alert.remove ()
        }
      } catch (e) {
        if (e.name != 'NotFoundError') {
          traceback (e)
        }
      }
      for (let func_id of func_ids) {
        delete store.state.$tmp.bs_runs [func_id]
      }
    }

    let global_toast_id = 0
    const DISPLAY_TIMEOUT = 600 * 1000

    async function bs_toast (option) {
      global_toast_id++
      if (!("bs_runs" in store.state.$tmp)) {store.state.$tmp.bs_runs = {}}
      if (!("subTitle" in option)) { option.subTitle = new Date ().format ('%b %d %I:%M %p') }
      if (!("icon" in option)) { option.icon = "info" }
      if (!("closeButtonText" in option)) { option.closeButtonText = "Close" }
      if (!("buttons" in option)) { option.buttons = [] }
      if (!("autoHide" in option)) { option.autoHide = 7000 }
      else {option.autoHide += 0}

      const icon = _createIcon (option.icon)
      const myToast = document.createElement ('div')
      myToast.setAttribute ("id", `bs-toast-${global_toast_id}`)
      myToast.setAttribute ("role", "alert")
      myToast.setAttribute ("aria-live", "assertive")
      myToast.setAttribute ("aria-atomic", true)
      myToast.setAttribute ("class", "toast my-1 elevation-10")

      if (option.buttons.length) {
        option.autoHide = 0
      }
      if (option.autoHide > 0) {
        myToast.setAttribute ("data-bs-delay", option.autoHide)
      }
      else {
        myToast.setAttribute ("data-bs-autohide", false)
      }

      buttons = ''
      const func_ids = []
      if (option.buttons.length) {
        buttons += `
        <div class="mt-2 pt-1 text-end">
          <!--button type="button" class="btn btn-outline-secondary btn-sm mr-2 p-0" data-bs-dismiss="toast">${option.closeButtonText}</button-->
        `

        let btn_id = 0
        for (let btn of option.buttons) {
          btn_id++
          const func_id = `fn${global_toast_id}_${btn_id}`
          func_ids.push (func_id)
          if (btn.run !== undefined) {
            store.state.$tmp.bs_runs [func_id] = btn.run
            buttons +=  `<button type="button" class="btn btn-sm px-2 py-1 mr-2 ${btn.class_}" data-bs-dismiss="toast" onClick="store.state.$tmp.bs_runs.${func_id}();">${btn.text}</button>`
          }
          else if (btn.to !== undefined) {
            {% if context.vue_config.use_router %}
              buttons += `<button type="button" class="btn btn-sm px-2 py-1 mr-2 ${btn.class_}" data-bs-dismiss="toast" onClick="router.push ('${btn.to}');">${btn.text}</button>`
            {% else %}
              buttons += `<a class="btn btn-sm px-2 py-1 mr-2 ${btn.class_}" href="${btn.to}">${btn.text}</a>`
            {% endif %}
          } else {
            buttons +=  `<button type="button" class="btn btn-sm px-2 py-1 mr-2 ${btn.class_}" data-bs-dismiss="toast">${btn.text}</button>`
          }
        }
        buttons += '</div>'
      }

      myToast.innerHTML = `
        <div class="toast-header bg-light-blue-lighten-5 py-1 px-2 border-0 rounded-top elevation-16 opacity-90">
          <strong class="me-auto"><span class="fs-6">${icon}</span> ${option.title}</strong><small>${option.subTitle}</small>
          <button type="button" class="btn-close" data-bs-dismiss="toast" aria-label="Close"></button>
        </div>
        <div class="toast-body bg-light-blue-lighten-5 rounded-bottom opacity-90">
          <div>${option.text}</div>
          ${buttons}
        </div>
      `
      const toastContainer = document.querySelector (".toast-container .position-fixed")
      toastContainer.appendChild (myToast)
      const w = new bootstrap.Toast(myToast)
      w.show ()
      await frontend.sleep (DISPLAY_TIMEOUT)
      w.dispose ()
      bs_cleanup (toastContainer, myToast, func_ids)
    }

    async function bs_flash (option) {
      global_toast_id++
      if (!("bs_runs" in store.state.$tmp)) {store.state.$tmp.bs_runs = {}}
      if (!("icon" in option)) { option.icon = "info" }
      if (!("class_" in option)) { option.class_ = "alert-primary" }
      if (!("autoHide" in option)) { option.autoHide = 7000 }
      else {option.autoHide += 0}
      if (!("buttons" in option)) { option.buttons = [] }

      const icon = _createIcon (option.icon)
      const myAlert = document.createElement ('div')
      myAlert.setAttribute ("id", `bs-toast-${global_toast_id}`)
      myAlert.setAttribute ("role", "alert")
      myAlert.setAttribute ("class", `alert ${option.class_} alert-dismissible fade show mt-1 mb-0 py-1 pl-4 pr-10`)

      buttons = ''
      const func_ids = []
      if (option.buttons.length) {
        let btn_id = 0
        for (let btn of option.buttons.reverse ()) {
          btn_id++
          const func_id = `fn${global_toast_id}_${btn_id}`
          func_ids.push (func_id)
          if (btn.run !== undefined) {
            store.state.$tmp.bs_runs [func_id] = btn.run
            buttons += `<button type="button" class="btn btn-sm px-2 py-0 mr-2 float-end ${btn.class_}" data-bs-dismiss="alert" onClick="store.state.$tmp.bs_runs.${func_id}();">${btn.text}</button>`
          }
          else if (btn.to !== undefined) {
            {% if context.vue_config.use_router %}
              buttons += `<button type="button" class="btn btn-sm px-2 py-0 mr-2 float-end ${btn.class_}" data-bs-dismiss="alert" onClick="router.push ('${btn.to}');">${btn.text}</button>`
            {% else %}
              buttons += `<a class="btn btn-sm px-2 py-0 mr-2 float-end ${btn.class_}" data-bs-dismiss="alert" href="${btn.to}">${btn.text}</a>`
            {% endif %}
          } else {
            buttons += `<button type="button" class="btn btn-sm px-2 py-0 mr-2 float-end ${btn.class_}" data-bs-dismiss="alert">${btn.text}</button>`
          }
        }
        buttons += '</div>'
      }

      myAlert.innerHTML = `
        <div class="clearfix">
        <span class="mb-2 mr-4">${icon}</span> ${option.text}
        ${buttons}
        <button type="button" class="btn-close btn-sm px-3 pt-1 pb-4 float-end" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
      `
      const alertContainer = document.querySelector (".alert-container")
      if (alertContainer == null) {
        throw new Error ("div.alert-container is required")
      }
      alertContainer.appendChild (myAlert)
      const w = new bootstrap.Alert(myAlert)
      await frontend.sleep (option.autoHide || DISPLAY_TIMEOUT)
      w.dispose ()
      bs_cleanup (alertContainer, myAlert, func_ids)
    }

    async function bs_popover (activator_css, content_css, _options = {}) {
      const [el_content, el_activator] = await Promise.all ([
        frontend.layout.wait_for_exist (content_css),
        frontend.layout.wait_for_exist (activator_css)
      ])
      if (!(!!el_content && !!el_activator)) {
        return
      }
      const options = {
        html: true,
        content: el_content,
        placement: 'auto',
        ..._options
      }
      if ('class_' in _options) {
        options.customClass = _options.class_
      }
      const popover = new bootstrap.Popover (el_activator, options)
    }

    // namespace aliasing
    bootstrap.modal = bs_modal
    bootstrap.wait = bs_wait
    bootstrap.flash = bs_flash
    bootstrap.toast = bs_toast
    bootstrap.popover = bs_popover

    bootstrap.enable_tooltip = () => {
      const tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
      tooltipTriggerList.map(function (tooltipTriggerEl) {
        return new bootstrap.Tooltip(tooltipTriggerEl)
      })
    }
    bootstrap.enable_popovers = () => {
      const popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
      popoverTriggerList.map(function (popoverTriggerEl) {
        return new bootstrap.Popover(popoverTriggerEl)
      })
    }
  </script>
{% endblock %}
